var states =[ 
["Western Australia","imgs/australiaocc.png","australiaoccl"],
["Northern Australia","imgs/australianord.png","australianordl"],
["Southern Australia","imgs/australiasud.png","australiasudl"],
["Queensland","imgs/queensland.png","queenslandl"],
["New South Wales","imgs/nuovogalles.png","nuovogallesl"],
["Victoria","imgs/victoria.png","victorial"],
["Tasmania","imgs/tasmania.png","tasmanial"],
["Australian Capital Territory","imgs/canberra.png","canberral"],
["New Zealand","imgs/nzelanda.png","nzelandal"],
["Cook Islands","imgs/cook.png","cookl"],
["Republic of Fiji","imgs/figi.png","figil"],
["Guam","imgs/guam.png","guaml"],
["Hawaii","imgs/hawaii.png","hawaiil"],
["Republic of Kiribati","imgs/kiribati.png","kiribatil"],
["Commonwealth of the Northern Mariana Islands (CNMI)","imgs/marianne.png","mariannel"],
["Republic of the Marshall Islands","imgs/marshall.png","marshalll"],
["Federated States of Micronesia","imgs/micronesia.png","micronesial"],
["Republic of Nauru","imgs/nauru.png","naurul"],
["Nlue","imgs/nlue.png","nluel"],
["New Caledonia","imgs/ncaledonia.png","ncaledonial"],
["Republic of Palau","imgs/palau.png","palaul"],
["Papua New Guinea","imgs/papua.png","papual"],
["Pitcairn Islands","imgs/pitcairn.png","pitcairnl"],
["French Polynesia","imgs/polinesia.png","polinesial"],
["Solomon Islands","imgs/salomone.png","salomonel"],
["Samoa","imgs/samoa.png","samoal"],
["American Samoa","imgs/samoaa.png","samoaal"],
["Tokelau","imgs/tokelau.png","tokelaul"],
["Kingdom of Tonga","imgs/tonga.png","tongal"],
["Tuvalu Islands","imgs/tuvalu.png","tuvalul"],
["Republic of Vanuatu","imgs/vanuatu.png","vanuatul"],
["Wallis Futuna","imgs/wallisfutuna.png","wallisfutunal"]
];
let indici=[];
for (let i=0; i<states.length; i++)
{	indici[i]=i;
}
function shuffle(array) 
{  let currentIndex = array.length, temporaryValue, randomIndex;
  // While there remain elements to shuffle...
  while (0 !== currentIndex) 
  {  // Pick a remaining element...
    randomIndex = Math.floor(Math.random() * currentIndex);
    currentIndex -= 1;
    // And swap it with the current element.
    temporaryValue = array[currentIndex];
    array[currentIndex] = array[randomIndex];
    array[randomIndex] = temporaryValue;
  }
  return array;
}
let ind=shuffle(indici);
let count=0, corrette=0, errate=0, index=1, end="", punteggio="", bad="";
window.onload = function () 
{  let ImageMap = function (map, img) 
   {  let n, areas = map.getElementsByTagName('area'),
      len = areas.length, coords = [], previousWidth = 985;
      for (n = 0; n < len; n++) 
      { coords[n] = areas[n].coords.split(',');
      }
      this.resize = function () 
      { let n, m, clen,
        x = img.offsetWidth / previousWidth;
        for (n = 0; n < len; n++) 
        { clen = coords[n].length;
          for (m = 0; m < clen; m++) 
          { coords[n][m] *= x;
          }
          areas[n].coords = coords[n].join(',');
        }
        previousWidth = img.offsetWidth;
        return true;
      };
      window.onresize = this.resize;
      map.addEventListener("click",eventClick);
	function eventClick(e)
	{	for(let i=0;i<len;i++)
		{
			if (areas[i]==e.target)
			check(states[i][0]);
		}
	}
    },
    imageMap = new ImageMap(document.getElementById('map'), document.getElementById('m'));
    imageMap.resize();
    document.getElementById('dhead').innerHTML=document.getElementById('dhead').innerHTML+" -- tap "+states[ind[count]][0];
    return;
}
function check(name)
{   let voice =	document.getElementById('dhead');
    let murder = document.getElementById('m');
	let len = states.length;
	for (let i=0; i<len; i++)
    {   document.getElementById(states[i][2]).style.display="none";
    }
    if(index<len)
	{	if(states[ind[count]][0]===name)
		{	murder.setAttribute("src",states[ind[count]][1]);
            document.getElementById(states[ind[count]][2]).style.display="block";
			count++;corrette++;index++;
			voice.innerHTML="ok, now tap "+states[ind[count]][0]+", got "+corrette+"/"+len;	
		}
		else if (states[ind[count]][0]!==name)
		{	errate++;
			voice.innerHTML="keep calm and look for "+states[ind[count]][0]+", got "+corrette+"/"+len;
			bad=bad+" "+states[ind[count]][0]+",";
		} 	
	}
	else if (index==len)
	{	if(states[ind[count]][0]===name)
		{	corrette++;index++;
			voice.innerHTML =	"<button  onclick='javascript:score()'>result</button>"+" "
			+"<button  onclick='javascript:location.reload();'>try again</button>";
			murder.setAttribute("src",states[ind[count]][1]);
		}
		else if (states[ind[count]][0]!==name)
		{	errate++;
			voice.innerHTML="keep calm and look for "+states[ind[count]][0]+", got "+corrette+"/"+len;
			bad=bad+" "+states[ind[count]][0]+",";
		} 
	}
	else if (index>len)
	{	return false;
	}
}
function score()
{	let score=(((corrette-errate)/corrette)*10).toFixed(2);
	if(score<=10 && score>=9)
	{	punteggio="excellent! "+ score+"/10";
	}
	else if(score<9 && score>=8)
	{	punteggio="very good! "+ score+"/10";
	}
	else if(score<8 && score>=7)
	{	punteggio="good! "+ score+"/10";
	}
	else if(score<7 && score>=6)
	{	punteggio="adequate "+ score+"/10";
	}
	else if(score<6)
	{	punteggio="not adequate "+ score+"/10";
	}
	end="<p style='text-align:left'>Test completed:<br>"
	+"- correct: "+corrette+"<br>"
	+"- wrong: "+errate+"<br>" 
	+"- result: "+punteggio+"<br>"
	+"- you didn't find: "+bad.substring(0,bad.length-1)+"<br></p>"
	+"<img src='imgs/oceania_1.jpg' style='width:40%'>";
	document.getElementById('cdiv').innerHTML=end;
}